/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

#define G_BLANK '#'
#define G_START 'x'
#define G_BULLET '.'
#define G_TREASURE '$'
#define G_POTION '!'
#define G_FOOD '%'
#define G_FLOOR '#'
#define G_POISON 'P'
#define G_GENGOB 'M'
#define G_GOB1 'N'
#define G_GOB2 'O'
#define G_CHAR 'A'
#define G_BURN1 'u'
#define G_BURN2 'v'
#define G_FBUL_U 'q'
#define G_FBUL_R 'r'
#define G_FBUL_D 's'
#define G_FBUL_L 't'
#define G_FBUL_UR 'q'
#define G_FBUL_DR 'r'
#define G_FBUL_DL 's'
#define G_FBUL_UL 't'
#define G_LIGHT_1 'E'
#define G_LIGHT_2 'F'
#define G_LIGHT_3 'G'
#define G_LIGHT_4 'H'
#define G_LIGHT_5 'I'
#define G_LIGHT_6 'J'
#define G_LIGHT_7 'K'
#define G_LIGHT_8 'L'
#define G_ARROW_1 'R'
#define G_ARROW_2 'S'
#define G_ARROW_3 'T'
#define G_ARROW_4 'U'
#define G_ARROW_5 'V'
#define G_ARROW_6 'W'
#define G_ARROW_7 'X'
#define G_ARROW_8 'Y'
#define G_BOW     ')'
#define G_DOOR_1  '|'
#define G_DOOR_2  '-'
#define G_KEY     '('
#define G_AXE     ']'
#define G_CLUB    '{'
#define G_SWORD   '}'
#define G_MACE    ':'
#define G_HELMET  ';'
#define G_ARMOUR  '['
#define G_SHIELD  '9'
#define G_BIRDIE1 '<'
#define G_BIRDIE2 '>'
#define G_NEST    ','
#define G_SCORPIE1 '`'
#define G_SCORPIE2 '~'
#define G_GENSCORP '?'
#define G_MUNCH1   '"'
#define G_MUNCH2   '+'
#define G_GENMUNCH '\''
#define G_MOUSE1   '\001'
#define G_MOUSE2   '\002'
#define G_GENMOUSE '\003'

#define MAXPLAYERS 16
#define STARTMAX 3000
#define MAX_BUF 256
#define MAX_X 128
#define MAX_Y 128

#define PLAYER 1
#define BULLET 2
#define MONSTER 3
#define TREASURE 4
#define POTION 5
#define FOOD 6
#define POISON 7
#define GENGOB 8
#define GOB 9
#define FBULLET 10
#define FBALL 11
#define LIGHTNING 12
#define ARROW 13
#define BOW 14
#define WEAPON 15
#define ARMOUR 16
#define MUNCH 17
#define GENMUNCH 18
#define BIRD 19
#define NEST 20
#define SCORP 21
#define GENSCORP 22
#define DOOR 23
#define KEY 24
#define MMISSILE 25

#define UNDO op->speed++,flag=1
#define WINUPPER (-5)
#define WINLOWER 5
#define WINLEFT (-5)
#define WINRIGHT 5
#define MAX_NAME 16
#define SIZEOFFREE 49
#define INFOLINES 46
#define INFOCHARS 52
#define S_BULLET 0
#define S_FIREBALL 1
#define S_LIGHTNING 2

