/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <signal.h>
#include "define.h"
#include "object.h"

typedef struct pl {
  int used,nr,state,infoline;
  int shoottype; /* What we're shooting */
  int shootstrength; /* Strength of spell */
  int writing; /* When true, the player is writing text to be displayed */
  living last_stats; /* Last stats drawin with draw_stats() */
  float last_speed;
  int last_value; /* Same usage as last_stats */
  char write_buf[MAX_BUF];
  char info[INFOLINES][MAX_BUF];
  Display *gdisp;
  Window win_root;
  Window win_game;
  Window win_stats;
  Window win_info;
  GC gc_root;
  GC gc_game;
  GC gc_stats;
  GC gc_info;
  XEvent gevent;
  KeySym gkey;
  XSizeHints gamehint;
  XSizeHints stathint;
  XSizeHints roothint;
  XSizeHints infohint;
  int gscreen;
  unsigned long gforeground,gbackground;
  Font font;
  object *ob; /* The object representing the player */
  char drawn[WINRIGHT-WINLEFT+1][WINLOWER-WINUPPER+1]; /* Last displayed */
  char name[MAX_NAME];
} player;

player players[MAXPLAYERS];

char map[MAX_X][MAX_Y];       /* What the map looks like now */
char omap[MAX_X][MAX_Y];      /* How the floor of the map looks */
object *map_ob[MAX_X][MAX_Y]; /* What object lies on the floor */

char errmsg[MAX_BUF];
int mapx,mapy,startx,starty;
int ob_count;

object *get_object();
object *get_player();
int gargc;
char **gargv;

void fprintf();
void exit();
void insert_ob_in_ob();
void insert_ob_in_map();
int find_free_player();
void draw_info();
void info_all();
int blocked();
void update_object();
int move_ob();
void hit_player();
int ftime();
void leave();
void draw();
void draw_all_info();
void xrEFreshKeyboardMapping();
void write_ch(object *,char);
int sscanf();
object *find_object();
void dump_object();
void dump_all_objects();
int count_used();
int count_free();
void usleep();
long random();
