/*
    CrossFire, A Multiplayer game for X-windows

    Copyright (C) 1992 Frank Tore Johansen

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The author can be reached via e-mail to frankj@ifi.uio.no.
*/

#include "living.h"

void fix_player(object *op) {
  int i;
  float f;
  for(i=0,op->stats.maxhp=0;i<=op->stats.level;i++)
    op->stats.maxhp+=op->stats.levhp[i]+con_bonus[op->stats.Con];
  for(i=0,op->stats.maxsp=0;i<=op->stats.level;i++)
    op->stats.maxsp+=op->stats.levsp[i]+int_bonus[op->stats.Int];
  op->stats.ac=10-dex_bonus[op->stats.Dex]-
               ((op->armour==NULL)?0:op->armour->stats.ac);
  op->stats.wc=21-op->stats.level-thaco_bonus[op->stats.Str]
               -((op->weapon==NULL)?0:op->weapon->stats.wc);
  op->stats.dam=((op->weapon==NULL)?2:op->weapon->stats.dam)+
                dam_bonus[op->stats.Str];
  op->speed=1.0+speed_bonus[op->stats.Dex];
  f=op->weight-max_carry[op->stats.Str];
  if(f>0) op->speed=op->speed/(1+f/max_carry[op->stats.Str]);
  draw_stats(op);
}

void add_exp(object *op,int exp) {
  char buf[MAX_BUF];
  op->stats.exp+=exp;
  if(op->type==PLAYER) {
    if(op->stats.exp>=levels[op->stats.level+1]) {
      op->stats.level++;
      op->stats.levhp[op->stats.level]=
        (int)random()%10+1+con_bonus[op->stats.Con];
      op->stats.levsp[op->stats.level]=
        (int)random()%10+1+int_bonus[op->stats.Int];
      fix_player(op);
      if(op->stats.level>1) {
        sprintf(buf,"You are now level %d.",op->stats.level);
        draw_info(op,buf);
      }
    } else if(op->stats.level>1&&op->stats.exp<levels[op->stats.level-1]) {
      op->stats.level--;
      fix_player(op);
      sprintf(buf,"You are now level %d.",op->stats.level);
      draw_info(op,buf);
    }
  }
}
